'use strict';

/* globals sinon, describe, expect, it */

var proxyquire = require('proxyquire').noPreserveCache();

var <%= name2 %>CtrlStub = {
  index: '<%= name2 %>Ctrl.index',
  show: '<%= name2 %>Ctrl.show',
  create: '<%= name2 %>Ctrl.create',
  upsert: '<%= name2 %>Ctrl.upsert',
  patch: '<%= name2 %>Ctrl.patch',
  destroy: '<%= name2 %>Ctrl.destroy'
};

var routerStub = {
  get: sinon.spy(),
  put: sinon.spy(),
  patch: sinon.spy(),
  post: sinon.spy(),
  delete: sinon.spy()
};

// require the index with our stubbed out modules
var <%= name2 %>Index = proxyquire('./index.js', {
  express: {
    Router() {
      return routerStub;
    }
  },
  './<%= name2 %>.controller': <%= name2 %>CtrlStub
});

describe('<%= name1 %> API Router:', function() {
  it('should return an express router instance', function() {
    expect(<%= name2 %>Index).to.equal(routerStub);
  });

  describe('GET /api/<%= name2 %>s', function() {
    it('should route to <%= name2 %>.controller.index', function() {
      expect(routerStub.get
        .withArgs('/', '<%= name2 %>Ctrl.index')
        ).to.have.been.calledOnce;
    });
  });

  describe('GET /api/<%= name2 %>s/:id', function() {
    it('should route to <%= name2 %>.controller.show', function() {
      expect(routerStub.get
        .withArgs('/:id', '<%= name2 %>Ctrl.show')
        ).to.have.been.calledOnce;
    });
  });

  describe('POST /api/<%= name2 %>s', function() {
    it('should route to <%= name2 %>.controller.create', function() {
      expect(routerStub.post
        .withArgs('/', '<%= name2 %>Ctrl.create')
        ).to.have.been.calledOnce;
    });
  });

  describe('PUT /api/<%= name2 %>s/:id', function() {
    it('should route to <%= name2 %>.controller.upsert', function() {
      expect(routerStub.put
        .withArgs('/:id', '<%= name2 %>Ctrl.upsert')
        ).to.have.been.calledOnce;
    });
  });

  describe('PATCH /api/<%= name2 %>s/:id', function() {
    it('should route to <%= name2 %>.controller.patch', function() {
      expect(routerStub.patch
        .withArgs('/:id', '<%= name2 %>Ctrl.patch')
        ).to.have.been.calledOnce;
    });
  });

  describe('DELETE /api/<%= name2 %>s/:id', function() {
    it('should route to <%= name2 %>.controller.destroy', function() {
      expect(routerStub.delete
        .withArgs('/:id', '<%= name2 %>Ctrl.destroy')
        ).to.have.been.calledOnce;
    });
  });
});
